const TaskBase=require("../../task.base");
var excel = require('exceljs');
const system = require("../../../system");
class ParseRptTask extends TaskBase{
  constructor(){
    super(TaskBase.getServiceName(ParseRptTask));
    this.cacheData=[];
    this.ossC=system.getObject("util.ossClient");
  }
  async subBeforeTask(params){
    console.log("前置操作......",this.serviceName);
    //this.isThrough=true;
    //console.log(this.cacheManager);
    this.isDaemon=true;
 }
  async subTaskHandle(channel, message){
    var x=await this.redisClient.rpop(message);
    if(x){
      this.cacheData.push(x);
    }
    setImmediate(async ()=>{
      await this.parseXls();
    });
  }
  //读取模板文件
async  readxls(path) {
  var promise = new Promise((resv, rej) => {
      var workbook = new excel.Workbook();
      workbook.properties.date1904 = true;
      workbook.xlsx.readFile(path)
          .then(function () {
              return resv(workbook);
          }).catch(function (e) {
              return rej(e);
          });
  });
  return promise;
}
  async parseXls(){
    var pv=this.cacheData.pop();
    if(pv){
      var tohandleurls=pv.split("~");
      var rptDate=tohandleurls[0];
      var rptCode=tohandleurls[1];
      var urldownload=tohandleurls[2];
      //下载文件
      var keyindex=urldownload.lastIndexOf("/");
      var keystr=urldownload.substring(keyindex+1);
      var result= await this.ossC.downfile(keystr);
      var localpath="/tmp/"+keystr;
      var wb= await this.readxls(localpath);
      var parserByCode=require("./rptHandler/"+rptCode);
      var rows=await parserByCode(wb);
      console.log(JSON.stringify(rows));

      this.parseXls();
    }
  }
  async subDoTask(params){
    console.log(params);
    console.log("TestTask1.....");
  }
}
module.exports=ParseRptTask;
